# -*- coding: utf -*-
from __future__ import unicode_literals

from driverng.protocol.acknack import ACKNACKProtocol
from driverng.utils import ETB, ETX


class Au680Protocol(ACKNACKProtocol):
    ACCEPTED_END_CHAR = [ETX, ETB]

    def __init__(self, **kwargs):
        kwargs.setdefault("checksum_type", self.CHECKSUM_BCC)
        kwargs.setdefault("max_tries", 1)
        kwargs.setdefault("timeout", 3)
        super(Au680Protocol, self).__init__(**kwargs)

    def send_trames(self, trame):
        sent = super(Au680Protocol, self).send_trames(trame)
        if sent and bytearray([trame[1]]) == b"S":
            return True
        else:
            return sent

    def recv_trames(self):
        payload = super(Au680Protocol, self).recv_trames()
        if payload and bytearray(payload[:2]) in (b"DE", b"DB", b"SE", b"RB", b"RE"):
            return []
        else:
            return payload
